package com.ejie.ab79.dao.actuaciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.actuaciones.Actuaciones;
import com.ejie.ab79.model.actuaciones.RelActDoc;
import com.ejie.ab79.model.plantillas.TiposPlantilla;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelActDocDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RelActDocDaoImpl implements RelActDocDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRELACTDOC", "IDACTUACION", "IDTIPOPLANTILLA",
			"IDDOCUMENTOMOVIL", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RelActDoc> rwMap = new RowMapper<RelActDoc>() {
		public RelActDoc mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelActDoc relActDoc = new RelActDoc();
			relActDoc.setIdRelActDoc(resultSet.getInt("IDRELACTDOC"));
			relActDoc.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			relActDoc.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			relActDoc.setEnviadoProSan(resultSet.getInt("ENVIADOPROSAN"));
			relActDoc.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));

			return relActDoc;

		}
	};

	private RowMapper<RelActDoc> rwMapPK = new RowMapper<RelActDoc>() {
		public RelActDoc mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelActDoc(resultSet.getInt("IDRELACTDOC"));
		}
	};

	/**
	 * Rowmapper para Jerarquia
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<RelActDoc>> rwMapJerarquia = new RowMapper<JerarquiaDto<RelActDoc>>() {
		public JerarquiaDto<RelActDoc> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelActDoc relActDoc = new RelActDoc();
			relActDoc.setIdRelActDoc(resultSet.getInt("IDRELACTDOC"));
			Actuaciones actuacion = new Actuaciones();
			actuacion.setIdActuacion(resultSet.getInt("IDACTUACION"));
			relActDoc.setActuacion(actuacion);
			relActDoc.setIdDocumentoMovil(resultSet.getString("IDDOCUMENTOMOVIL"));
			relActDoc.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			relActDoc.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			TiposPlantilla tipoPlantilla = new TiposPlantilla();
			tipoPlantilla.setIdTipoPlantilla(resultSet.getLong("IDTIPOPLANTILLA"));
			tipoPlantilla.setDescripcionCastellano(resultSet.getString("TIPOPLANTILLADESCES"));
			tipoPlantilla.setDescripcionEuskera(resultSet.getString("TIPOPLANTILLADESCEU"));

			JerarquiaDto<RelActDoc> jerarquia = new JerarquiaDto<RelActDoc>();
			jerarquia.setModel(relActDoc);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @return RelActDoc
	 */
	public RelActDoc add(RelActDoc relactdoc) {

		int idRelActDoc = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7929T00.NEXTVAL FROM DUAL",
				Integer.class);
		relactdoc.setIdRelActDoc(idRelActDoc);

		String query = "INSERT INTO REL_ACT_DOC (ID_REL_ACT_DOC, ID_ACTUACION, ID_DOCUMENTO_MOVIL, ENVIADO_PRO_SAN, ID_DOCUMENTO_SUBIDO, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,sysdate,?)";
		this.jdbcTemplate.update(query, relactdoc.getIdRelActDoc(),
				relactdoc.getActuacion() != null ? relactdoc.getActuacion().getIdActuacion() : null,
				relactdoc.getIdDocumentoMovil(), relactdoc.getEnviadoProSan(), relactdoc.getIdDocumentoSubido(),
				relactdoc.getUsuarioRegistro());
		return relactdoc;
	}

	@Override
	public RelActDoc updateEnviadoProSan(RelActDoc relActDoc) {
		String query = "UPDATE REL_ACT_DOC SET ENVIADO_PRO_SAN = ? WHERE ID_REL_ACT_DOC = ?";
		this.jdbcTemplate.update(query, relActDoc.getEnviadoProSan(), relActDoc.getIdRelActDoc());
		return relActDoc;

	}

	/**
	 * Finds a single row in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @return RelActDoc
	 */
	@Transactional(readOnly = true)
	public RelActDoc find(RelActDoc relactdoc) {
		String query = "SELECT t1.ID_REL_ACT_DOC IDRELACTDOC, t1.ID_ACTUACION IDACTUACION, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA, t1.ENVIADO_PRO_SAN ENVIADOPROSAN, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.DESCRIPCION_CASTELLANO TIPOPLANTILLADESCES, t2.DESCRIPCION_EUSKERA TIPOPLANTILLADESCEU FROM REL_ACT_DOC t1,TIPOS_PLANTILLA t2 WHERE t1.ID_REL_ACT_DOC = ? AND t1.ID_TIPO_PLANTILLA = t2.ID_TIPO_PLANTILLA ";

		List<RelActDoc> relactdocList = this.jdbcTemplate.query(query, this.rwMap, relactdoc.getIdRelActDoc());
		return (RelActDoc) DataAccessUtils.uniqueResult(relactdocList);
	}

	/**
	 * Removes a single row in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @return
	 */
	public void remove(RelActDoc relactdoc) {
		String query = "DELETE FROM REL_ACT_DOC WHERE ID_REL_ACT_DOC=?";
		this.jdbcTemplate.update(query, relactdoc.getIdRelActDoc());
	}

	@Override
	public void removeByIdDocumentoSubido(RelActDoc relActDoc) {
		String query = "DELETE FROM REL_ACT_DOC WHERE ID_DOCUMENTO_SUBIDO=?";
		this.jdbcTemplate.update(query, relActDoc.getIdDocumentoSubido());
	}

	@Override
	public void removeByIdActuacion(Integer idActuacion) {
		String query = "DELETE FROM REL_ACT_DOC WHERE ID_ACTUACION=?";
		this.jdbcTemplate.update(query, idActuacion);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<RelActDoc> getMultiple(RelActDoc filterRelActDoc, TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRelActDoc, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RelActDoc.class, params,
				"ID_REL_ACT_DOC");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RelActDoc>
	 */
	@Transactional(readOnly = true)
	public List<RelActDoc> findAll(RelActDoc relactdoc, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ACT_DOC IDRELACTDOC, t1.ID_ACTUACION IDACTUACION, t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ENVIADO_PRO_SAN ENVIADOPROSAN, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append(" FROM REL_ACT_DOC t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relactdoc);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelActDocDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelActDoc>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the RelActDoc table using like.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelActDoc>
	 */
	@Transactional(readOnly = true)
	public List<RelActDoc> findAllLike(RelActDoc relactdoc, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.ENVIADO_PRO_SAN ENVIADOPROSAN,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.DESCRIPCION_CASTELLANO TIPOPLANTILLADESCES, t2.DESCRIPCION_EUSKERA TIPOPLANTILLADESCEU ");
		query.append("FROM REL_ACT_DOC t1, TIPOS_PLANTILLA t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relactdoc, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TIPO_PLANTILLA = t2.ID_TIPO_PLANTILLA ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		// if (tableRequestDto != null) {
		// query = TableManager.getPaginationQuery(tableRequestDto, query,
		// RelActDocDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		return (List<RelActDoc>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(RelActDoc relactdoc) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_ACT_DOC t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relactdoc);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the RelActDoc table using like.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RelActDoc relactdoc, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_ACT_DOC t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relactdoc, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of RelActDoc selected for rup_table
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActDoc>>
	 */
	@Override
	public List<TableRowDto<RelActDoc>> reorderSelection(RelActDoc relactdoc, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_ACT_DOC t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relactdoc, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, RelActDoc.class,
				filterParamList, "ID_REL_ACT_DOC");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelActDoc>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            RelActDoc
	 * @param searchParams
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelActDoc>>
	 */
	@Override
	public List<TableRowDto<RelActDoc>> search(RelActDoc filterParams, RelActDoc searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_ACT_DOC t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, RelActDoc.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_REL_ACT_DOC");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelActDoc>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterrelactdoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RelActDoc filterrelactdoc, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM REL_ACT_DOC t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterrelactdoc, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, RelActDoc.class, query,
				params, "ID_REL_ACT_DOC");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical RelActDoc table.
	 *
	 * @param filterRelActDoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<RelActDoc>>
	 */
	@Override
	public List<JerarquiaDto<RelActDoc>> findAllLikeJerarquia(RelActDoc filterRelActDoc,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_ACT_DOC t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_ACT_DOC");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelActDoc, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_REL_ACT_DOC", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					RelActDocDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelActDoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(RelActDoc filterRelActDoc, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_ACT_DOC t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_ACT_DOC");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelActDoc, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_REL_ACT_DOC",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelActDoc
	 *            RelActDoc
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<RelActDoc>>
	 */
	@Override
	public List<TableRowDto<RelActDoc>> findAllChild(RelActDoc filterRelActDoc, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_ACT_DOC t1 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_ACT_DOC");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelActDoc, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_REL_ACT_DOC",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RelActDoc>(this.rwMapPK, "ID_REL_ACT_DOC"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelActDoc entity
	 *
	 * @param relactdoc
	 *            RelActDoc Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RelActDoc relactdoc) {

		StringBuilder where = new StringBuilder(RelActDocDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relactdoc != null && relactdoc.getIdRelActDoc() != null) {
			where.append(" AND t1.ID_REL_ACT_DOC = ?");
			params.add(relactdoc.getIdRelActDoc());
		}
		if (relactdoc != null && relactdoc.getActuacion() != null
				&& relactdoc.getActuacion().getIdActuacion() != null) {
			where.append(" AND t1.ID_ACTUACION = ?");
			params.add(relactdoc.getActuacion().getIdActuacion());
		}
		if (relactdoc != null && relactdoc.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(relactdoc.getFechaRegistro());
		}
		if (relactdoc != null && relactdoc.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(relactdoc.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelActDoc entity
	 *
	 * @param relactdoc
	 *            RelActDoc Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RelActDoc relactdoc, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RelActDocDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relactdoc != null && relactdoc.getIdRelActDoc() != null) {
			where.append(" AND t1.ID_REL_ACT_DOC = ?");
			params.add(relactdoc.getIdRelActDoc());
		}
		if (relactdoc != null && relactdoc.getActuacion() != null
				&& relactdoc.getActuacion().getIdActuacion() != null) {
			where.append(" AND t1.ID_ACTUACION = ?");
			params.add(relactdoc.getActuacion().getIdActuacion());
		}
		if (relactdoc != null && relactdoc.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(relactdoc.getFechaRegistro());
		}
		if (relactdoc != null && relactdoc.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relactdoc.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + relactdoc.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	/**
	 * 
	 *
	 * @param idInspeccion
	 *            Integer
	 * 
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long documentosSinEnviar(Integer idInspeccion) {

		StringBuilder query = new StringBuilder();
		query.append("SELECT COUNT(*)");
		query.append(" FROM REL_ACT_DOC t29");
		query.append(" INNER JOIN ACTUACIONES t14 ON t29.ID_ACTUACION = t14.ID_ACTUACION");
		query.append(" INNER JOIN DOCUMENTOS_SUBIDOS t52 ON t29.ID_DOCUMENTO_SUBIDO = t52.ID_DOCUMENTO_SUBIDO");
		query.append(" WHERE t14.ID_INSPECCION = ?");
		query.append(" AND t52.APORTADO_EXPEDIENTE = " + Constantes.APORTADO_EXPEDIENTE_NO);

		return this.jdbcTemplate.queryForObject(query.toString(), new Object[] { idInspeccion }, Long.class);
	}

	/**
	 * Finds a list of rows in the RelActDoc table.
	 *
	 * @param relactdoc
	 *            RelActDoc
	 * 
	 * @return List<RelActDoc>
	 */
	@Transactional(readOnly = true)
	public List<RelActDoc> findAllPropuestaSancion(RelActDoc relactdoc) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_ACT_DOC IDRELACTDOC,t1.ID_ACTUACION IDACTUACION,t1.ID_DOCUMENTO_MOVIL IDDOCUMENTOMOVIL, t1.ID_TIPO_PLANTILLA IDTIPOPLANTILLA,t1.ENVIADO_PRO_SAN ENVIADOPROSAN,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.DESCRIPCION_CASTELLANO TIPOPLANTILLADESCES, t2.DESCRIPCION_EUSKERA TIPOPLANTILLADESCEU ");
		query.append("FROM REL_ACT_DOC t1, TIPOS_PLANTILLA t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapPropuestaSancion(relactdoc);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TIPO_PLANTILLA = t2.ID_TIPO_PLANTILLA ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelActDoc entity
	 *
	 * @param relactdoc
	 *            RelActDoc Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMapPropuestaSancion(RelActDoc relactdoc) {

		StringBuilder where = new StringBuilder(RelActDocDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relactdoc != null && relactdoc.getIdRelActDoc() != null) {
			where.append(" AND t1.ID_REL_ACT_DOC = ?");
			params.add(relactdoc.getIdRelActDoc());
		}
		if (relactdoc != null && relactdoc.getActuacion() != null
				&& relactdoc.getActuacion().getIdActuacion() != null) {
			where.append(" AND t1.ID_ACTUACION = ?");
			params.add(relactdoc.getActuacion().getIdActuacion());
		}
		if (relactdoc != null && relactdoc.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(relactdoc.getFechaRegistro());
		}
		if (relactdoc != null && relactdoc.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(relactdoc.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

}
